#!/usr/bin/env bash

# Prepare the working directory.
WORKDIR="/tmp/heru-bootstrap"
rm -rf $WORKDIR && mkdir -p $WORKDIR && cd $WORKDIR

# Clone heru and coffee-script into it.
git clone http://github.com/wereHamster/heru.git
git clone http://github.com/jashkenas/coffee-script.git

# Extract the heru code into the tarball directory.
mkdir tarball
GIT_DIR=heru/.git git archive HEAD | tar -xf - -C tarball/

# Copy the coffee-script `coffee` binary and all required files.
cp coffee-script/bin/coffee tarball/bin/
cp -r coffee-script/lib tarball

# Pack the tarball.
tar -czvf bootstrap.tar.gz -C tarball .

